/* Public domain. */

#include <signal.h>
#include "floatasm.h2"

void nope()
{
  _exit(1);
}

int main(void)
{
  register double a;
  register double b;
  register double c;
  register double d;
#define SET(w,x,y,z) a = w; b = x; c = y; d = z;
#define CHECK(w,x,y,z) if (a != w) nope(); if (b != x) nope(); if (c != y) nope(); if (d != z) nope();

  signal(SIGILL,nope);

  SET(314,159,265,358) FLOATASM_ADD(a,b,c); CHECK(159 + 265,159,265,358)
  SET(314,159,265,358) FLOATASM_SUB(a,b,c); CHECK(159 - 265,159,265,358)
  SET(314,159,265,358) FLOATASM_MUL(a,b,c); CHECK(159*265,159,265,358)
  SET(314,159,265,358) FLOATASM_MADD(a,b,c,d); CHECK(159*265 + 358,159,265,358)
  SET(314,159,265,358) FLOATASM_MSUB(a,b,c,d); CHECK(159*265 - 358,159,265,358)
  SET(314,159,265,358) FLOATASM_NMADD(a,b,c,d); CHECK(-159*265 - 358,159,265,358)
  SET(314,159,265,358) FLOATASM_NMSUB(a,b,c,d); CHECK(-159*265 + 358,159,265,358)

  _exit(0);
}
